abuild.in 37.4 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
abuildrepo_base=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
14
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
15

16
program=${0##*/}
17
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
18 19

# defaults
20
BUILD_BASE="build-base"
21
FAKEROOT=${FAKEROOT:-"fakeroot"}
22

23 24
: ${SUDO_APK:=abuild-apk}
: ${APK:=apk}
25 26 27
: ${ADDUSER:=abuild-adduser}
: ${ADDGROUP:=abuild-addgroup}

28
apk_opt_wait="--wait 30"
29

Natanael Copa's avatar
Natanael Copa committed
30
# read config
Natanael Copa's avatar
Natanael Copa committed
31
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
32 33
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

34
default_colors() {
Natanael Copa's avatar
Natanael Copa committed
35 36 37 38 39 40
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
41 42 43 44 45 46 47 48 49 50 51 52 53 54
}

monochrome() {
	NORMAL=""
	STRONG=""
	RED=""
	GREEN=""
	YELLOW=""
	BLUE=""
}

#colors
if [ -n "$USE_COLORS" ]; then
    default_colors
Natanael Copa's avatar
Natanael Copa committed
55 56 57 58 59
fi	
	

# functions
msg() {
60
	[ -n "$quiet" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
61 62 63
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
64 65 66 67 68 69 70
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

msg2() {
	[ -n "$quiet" ] && return 0
	#      ">>> %s"
	printf "    %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
71 72 73 74 75 76
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
77 78 79 80 81 82
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

warning2() {
	#      ">>> WARNING: 
	printf "             %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
83 84 85 86 87 88
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
89 90 91 92 93 94
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

error2() {
	#      ">>> ERROR: 
	printf "           %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
95
}
Natanael Copa's avatar
Natanael Copa committed
96

Linux User's avatar
Linux User committed
97
set_xterm_title() {
98
	if [ "$TERM" = xterm ] && [ -n "$USE_COLORS" ]; then
99
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
100 101 102 103 104
	fi
} 

cleanup() {
	set_xterm_title ""
105
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
106
		msg "Uninstalling dependencies..."
107
		$SUDO_APK del --quiet $apk_opt_wait $uninstall_after
108
	fi
109 110 111
	if [ -n "$CLEANUP_FILES" ]; then
		rm -f $CLEANUP_FILES
	fi
Linux User's avatar
Linux User committed
112 113
}

Natanael Copa's avatar
Natanael Copa committed
114
die() {
Linux User's avatar
Linux User committed
115
	error "$@"
Linux User's avatar
Linux User committed
116
	cleanup
Natanael Copa's avatar
Natanael Copa committed
117 118 119
	exit 1
}

120
# check if apkbuild is basicly sane
121
default_sanitycheck() {
122
	local i= j= suggestion=
123
	msg "Checking sanity of $APKBUILD..."
124 125 126
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
127
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
128
		$APK version --check -q "$pkgver" ||\
Natanael Copa's avatar
Natanael Copa committed
129 130
			die "$pkgver is not a valid version"
	fi
131
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
132 133 134 135
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

Natanael Copa's avatar
Natanael Copa committed
136 137
	if [ -n "$replaces_priority" ] \
		&& ! echo $replaces_priority | egrep -q '^[0-9]+$'; then
138 139
		die "replaces_priority must be a number"
	fi
140 141 142 143 144 145 146
	# check so no package names starts with -
	for i in $pkgname $subpackages; do
		case $i in
		-*) die "${i%:*} is not a valid package name";;
		esac
	done

147 148 149 150 151 152 153 154 155 156
	# check if CARCH, CBUILD, CHOST and CTARGET is set
	if [ -z "$CARCH" ]; then
		case "$(uname -m)" in
		i[0-9]86) suggestion=" (Suggestion: CARCH=x86)";;
		x86_64) suggestion=" (Suggestion: CARCH=x86_64)";;
		esac
		die "Please set CARCH in /etc/abuild.conf$suggestion"
	fi
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"

Natanael Copa's avatar
Natanael Copa committed
157
	for i in $install; do
158
		local n=${i%.*}
159
		local suff=${i##*.}
160 161 162 163 164
		case "$suff" in
		pre-install|post-install|pre-upgrade|post-upgrade|pre-deinstall|post-deinstall);;
		*) die "$i: unknown install script suffix"
		esac
		if ! subpackages_has "$n" && [ "$n" != "$pkgname" ]; then
165
			die "$i: install script does not match pkgname or any subpackage"
166
		fi
167
		[ -e "$startdir/$i" ] || die "install script $i is missing"
168 169 170 171 172 173
		for j in chown chmod chgrp; do
			if grep -q $j "$startdir"/$i; then
				warning "$i: found $j"
				warning2 "Permissions should be fixed in APKBUILD package()"
			fi
		done
Natanael Copa's avatar
Natanael Copa committed
174 175
	done
	
176 177 178 179 180 181 182 183
	for i in $triggers; do
		local f=${i%=*}
		local p=${f%.trigger}
		[ "$f" = "$i" ] && die "$f: triggers must contain '='" 
		[ "$p" = "$f" ] && die "$f: triggers scripts must have .trigger suffix"
		if ! subpackages_has "$p" && [ "$p" != "$pkgname" ]; then
			die "$p: trigger script does not match pkgname or any subpackage"
		fi
Natanael Copa's avatar
Natanael Copa committed
184

185 186
		[ -e "$startdir"/$f ] || die "trigger script $f is missing"
	done
187 188
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
189 190 191 192
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
193
			md5sums_has ${i##*/} || die "${i##*/} is missing in md5sums"
Natanael Copa's avatar
Natanael Copa committed
194
			case "$i" in
195
				https://*) makedepends_has wget && warning "wget no longer need to be in makedepends when source has https://" ;;
Natanael Copa's avatar
Natanael Copa committed
196
			esac
197 198
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
199

200 201
	if [ -n "$md5sums" ]; then
		for i in $(echo "$md5sums" | awk '{ print $2 }'); do
Natanael Copa's avatar
Natanael Copa committed
202
			source_has $i || die "$i exists in md5sums but is missing in source"
203 204
		done
	fi
205

206 207 208
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
209 210

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
211 212

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
213 214 215
	return 0
}

216 217 218 219
sanitycheck() {
	default_sanitycheck
}

220
md5check() {
221
	local dummy f endreturnval originalparams origin file
222 223 224
	if [ -z "$source" ]; then
		return 0
	fi
225
	if [ -z "$md5sums" ]; then
226
		die "Use 'abuild checksum' to generate/update the checksum(s)"
227
	fi
228 229 230
	if [ "$(echo $source | wc -l)" -ne "$(echo $md5sums | wc -l)" ]; then
		die "Number of md5sums does not correspond to number of sources"
	fi
231
	fetch || return 1
232
	msg "Checking md5sums..."
Natanael Copa's avatar
Natanael Copa committed
233
	cd "$srcdir" || return 1
234 235 236 237 238 239 240 241
	IFS=$'\n'
	endreturnval=0
	originalparams=$@
	set -- $source
	for src in $md5sums; do
		origin=$1; shift
		echo "$src" | md5sum -c
		if [ $? -ne 0 ]; then
242
			endreturnval=1
243 244 245 246 247 248 249 250 251 252 253
			is_remote $origin || continue
			echo "Because the remote file above failed the md5sum check it will be deleted."
			echo "Rebuilding will cause it to re-download which in some cases may fix the problem."
			file=`echo "$src" | sed 's/.*[ \t\n]\(.*\)/\1/'`
			echo "Deleting: $file"
			rm $file
		fi
	done
	unset IFS
	set -- $originalparams
	return $endreturnval
Natanael Copa's avatar
Natanael Copa committed
254 255
}

Natanael Copa's avatar
Natanael Copa committed
256 257
# verify upstream sources
sourcecheck() {
258 259 260 261 262 263 264 265 266 267
	local uri
	for uri in $source; do
		is_remote $uri || continue
		case "$uri" in
		saveas-*://*)
			uri=${uri#saveas-}
			uri=${uri%/*}
			;;
		esac
		wget -q -s "$uri" || return 1
Natanael Copa's avatar
Natanael Copa committed
268
	done
269
	return 0
Natanael Copa's avatar
Natanael Copa committed
270
}
271

272 273 274
# convert curl options to wget options and call wget instead of curl
wget_fallback() {
	local wget_opts= outfile= opt=
275
	while getopts "C:Lko:s" opt; do
276
		case $opt in
277
		'L') ;; # --location. wget does this by default
278
		'f') ;; # --fail. wget does this by default
279 280 281 282 283 284 285 286 287 288
		'C') wget_opts="$wget_opts -c";; # --continue-at
		's') wget_opts="$wget_opts -q";; # --silent
		'o') wget_opts="$wget_opts -O $OPTARG";; # --output
		'k') wget_opts="$wget_opts --no-check-certificate";; #gnu wget
		esac
	done
	shift $(( $OPTIND - 1 ))
	wget $wget_opts "$1"
}

Natanael Copa's avatar
Natanael Copa committed
289 290
uri_fetch() {
	local uri="$1"
291
	local d="${uri##*/}"	# $(basename $uri)
292
	local opts
293
	[ -n "$quiet" ] && opts="-s"
294 295

	local lockfile="$SRCDEST/$d".lock
296

297 298 299 300 301
	# fix saveas-*://* URIs
	case "$uri" in
		# remove 'saveas-' from beginning and
		# '/filename' from end of URI
		saveas-*://*) uri="${uri:7:$(expr ${#uri} - 7 - ${#d} - 1)}";;
Natanael Copa's avatar
Natanael Copa committed
302
	esac
303 304

	case "$uri" in
305
		https://*) opts="-k";;
306
	esac
307

Natanael Copa's avatar
Natanael Copa committed
308
	mkdir -p "$SRCDEST"
309 310 311

	CLEANUP_FILES="$CLEANUP_FILES $lockfile"
	(
312 313
	flock -n -x 9 || msg "Waiting for ${lockfile##*/}..."
	flock -x 9
314 315 316

	[ -f "$SRCDEST/$d" ] && exit 0 # use exit since its a subshell

317 318
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
319
		opts="$opts -C -"
Natanael Copa's avatar
Natanael Copa committed
320
	fi
Linux User's avatar
Linux User committed
321
	msg "Fetching $uri"
322 323

	# fallback to wget if curl is missing. useful for bootstrapping
324
	local fetcher=
325 326
	if ! [ -x "$(which curl)" ]; then
		fetcher=wget_fallback
327 328
	else
		fetcher=curl
329
		opts="$opts -L -f -k"
330 331 332
	fi

	$fetcher $opts -o "$SRCDEST/$d.part" "$uri" \
333
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
334

335
	) 9>$lockfile
336 337 338 339

	local rc=$?
	rm -f "$lockfile"
	return $rc
Natanael Copa's avatar
Natanael Copa committed
340 341
}

342 343
is_remote() {
	case "$1" in
344
		http://*|ftp://*|https://*|saveas-*://*)
345 346 347 348 349
			return 0;;
	esac
	return 1
}

350 351 352 353 354
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	local d="${uri##*/}"	# $(basename $uri)
	if [ -n "$DISTFILES_MIRROR" ]; then
355 356 357 358 359
		if is_remote "$DISTFILES_MIRROR"; then
			uri_fetch "$DISTFILES_MIRROR"/$d && return 0
		else
			cp "$DISTFILES_MIRROR"/$d "$SRCDEST" && return 0
		fi
360 361 362 363
	fi
	uri_fetch "$uri"
}

364
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
365 366
	local s
	mkdir -p "$srcdir"
367 368
	for s in $source; do
		if is_remote "$s"; then
369
			uri_fetch_mirror "$s" || return 1
370 371 372 373
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
374 375 376
	done
}

377 378 379 380
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
381 382 383 384 385 386 387 388 389 390 391 392 393 394 395
# verify that all init.d scripts are openrc runscripts
initdcheck() {
	local i
	for i in $source; do
		case $i in
		*.initd)
			head -n 1 "$srcdir"/$i | grep -q '/sbin/runscript' \
				&& continue
			error "$i is not an openrc #!/sbin/runscript"
			return 1
			;;
		esac
	done			
}

Natanael Copa's avatar
Natanael Copa committed
396
# unpack the sources
397
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
398
	local u
399 400
	if [ -z "$force" ]; then
		md5check || return 1
Natanael Copa's avatar
Natanael Copa committed
401
		initdcheck || return 1
402
	fi
Natanael Copa's avatar
Natanael Copa committed
403 404 405 406
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
Natanael Copa's avatar
Natanael Copa committed
407
			*.tar.gz|*.tgz)
408
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
409 410
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
411
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
412
				tar -C "$srcdir" -jxf "$s" || return 1;;
413 414 415 416
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
417 418 419
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
420 421 422
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
423 424 425 426
		esac
	done
}

427 428 429 430
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
431 432
# cleanup source and package dir
clean() {
433
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
434
	rm -rf "$srcdir"
435
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
436 437 438 439 440 441
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
442 443 444 445
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
446 447 448
	done
}

449 450 451 452 453 454 455 456 457 458
listpkgnames() {
	local i
	for i in $pkgname $subpackages; do
		echo ${i%:*}
	done
	for i in $linguas; do
		echo $pkgname-lang-$i
	done
}

Natanael Copa's avatar
Natanael Copa committed
459 460
cleanpkg() {
	local i
461
	getpkgver || return 1
462
	msg "Cleaning built packages..."
463
	for i in $(listpkgnames); do
464 465
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
466
			"$abuildrepo"/$p.apk "$abuildrepo"/*/$p.apk
Natanael Copa's avatar
Natanael Copa committed
467
	done
468
	# remove given packages from index
Natanael Copa's avatar
Natanael Copa committed
469 470
}

471 472 473
# clean all packages except current
cleanoldpkg() {
	local i j
474
	getpkgver || return 1
475
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
476
	for i in $(listpkgnames); do
477 478 479 480 481
		local pn=${i%:*}
		for j in "$PKGDEST"/$pn-[0-9]*.apk ; do
			[ "$j" = "$PKGDEST/$pn-$pkgver-r$pkgrel.apk" ] \
				&& continue
			rm -f "$j" "$abuildrepo"/*/${j##*/}
482 483 484 485
		done
	done
	return 0
}
486 487 488

mkusers() {
	local i
489 490 491 492 493 494
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$ADDGROUP -S $i || return 1
		fi
	done
495 496
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
497
			local gopt=
498
			msg "Creating user $i"
499 500 501
			if getent group $i >/dev/null; then
				gopt="-G $i"
			fi
502
			$ADDUSER -S -D -H $gopt $i || return 1
503 504 505 506 507
		fi
	done
}


Natanael Copa's avatar
Natanael Copa committed
508 509
runpart() {
	local part=$1
510
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
511 512 513 514
	$part || die "$part failed"
}

# override those in your build script
515 516 517 518 519 520 521 522
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
523 524 525 526
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
527
build() {
528
	:
Natanael Copa's avatar
Natanael Copa committed
529 530
}

531 532 533
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
Natanael Copa's avatar
Natanael Copa committed
534
	mkdir -p "$PKGDEST"
535 536 537
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

Natanael Copa's avatar
Natanael Copa committed
538 539 540 541 542 543 544 545 546
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

547 548 549
postcheck() {
	local dir="$1" name="$2" i=
	msg "Running postcheck for $name"
550
	# checking for FHS compat
Natanael Copa's avatar
Natanael Copa committed
551 552 553 554 555 556 557 558
	if ! options_has "!fhs"; then
		for i in "$dir"/srv/* "$dir"/usr/local/* "$dir"/opt/*; do
			if [ -e "$i" ]; then
				error "Packages must not put anything under /srv, /usr/local or /opt"
				return 1
			fi
		done
	fi
559 560 561 562 563 564 565 566 567 568 569 570 571
	# look for *.la files
	i=$(find "$dir" -name '*.la' | sed "s|^$dir|\t|")
	if [ -n "$i" ] && ! options_has "libtool"; then
		error "Libtool archives (*.la) files found and \$options has no 'libtool' flag:"
		echo "$i"
		return 1
	fi
	# check directory permissions
	i=$(find "$dir" -type d -perm -777 | sed "s|^$dir|\t|")
	if [ -n "$i" ]; then
		warning "World writeable directories found:"
		echo "$i"
	fi
572 573 574 575 576 577 578 579 580
	# check so we dont have any suid root binaries that are not 
	i=$(find "$dir" -type f -perm +6000 \
		| xargs scanelf --nobanner --etype ET_EXEC \
		| sed "s|ET_EXEC $dir|\t|")
	if [ -n "$i" ]; then
		error "Found non-PIE files that has SUID:"
		echo "$i"
		return 1
	fi
581 582 583
	return 0
}

584
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
585 586
	local i
	cd "$startdir"
587
	for i in $subpackages; do
Natanael Copa's avatar
Natanael Copa committed
588 589
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
590
		msg "Running split function $func..."
591 592
		local dir="$pkgbasedir/${i%:*}" name="${i%:*}"
		subpkgdir="$dir" subpkgname="$name" \
593
			$0 $func prepare_package || return 1
594
		postcheck "$dir" "$name" || return 1
Natanael Copa's avatar
Natanael Copa committed
595
	done
596
	postcheck "$pkgdir" "$pkgname" || return 1
597 598
	# post check for /usr/share/locale
	if [ -d "$pkgdir"/usr/share/locale ]; then
599
		warning "Found /usr/share/locale"
600
		warning2 "Maybe add \$pkgname-lang to subpackages?"
601
	fi
Natanael Copa's avatar
Natanael Copa committed
602 603
}

604
default_lang() {
605
	pkgdesc="Languages for package $pkgname"
606 607 608 609 610 611 612 613 614 615 616 617 618
	install_if="$pkgname=$pkgver-r$pkgrel lang"
	arch="noarch"
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/${dir%/*}
		mv "$pkgdir"/"$dir" "$subpkgdir"/"$dir" || return 1
	done
}

lang() {
	default_lang
}

619
default_lang_subpkg() {
620 621 622 623
	if [ -z "$lang" ]; then
		error "lang is not set"
		return 1
	fi
624
	pkgdesc="$pkgname language pack for $lang"
625 626
	arch="noarch"
	install_if="$pkgname=$pkgver-r$pkgrel lang-$lang"
627 628 629 630 631
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/$dir
		mv "$pkgdir"/$dir/$lang* \
		"$subpkgdir"/$dir/ \
632
		|| return 1
633 634 635 636 637
	done
}

lang_subpkg() {
	default_lang_subpkg
638 639 640 641 642 643 644 645 646 647 648
}

prepare_language_packs() {
	for lang in $linguas; do
		lang="$lang" \
		subpkgname="$pkgname-lang-$lang" \
		subpkgdir="$pkgbasedir"/$subpkgname \
			$0 lang_subpkg prepare_package || return 1
	done
}

649 650 651 652 653 654 655 656 657 658 659 660
# echo '-dirty' if git is not clean
git_dirty() {
	if [ $(git status -s "$startdir" | wc -l) -ne 0 ]; then
		echo "-dirty"
	fi
}

# echo last commit hash id
git_last_commit() {
	git log --format=oneline -n 1 "$startdir" | awk '{print $1}'
}

661 662 663 664 665 666
get_maintainer() {
	if [ -z "$maintainer" ]; then
		maintainer=$(awk -F': ' '/\# *Maintainer/ {print $2}' "$APKBUILD")
	fi
}

667
prepare_metafiles() {
668
	getpkgver || return 1
669 670
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
671
	local dir=${subpkgdir:-$pkgdir}
672
	local pkg="$name-$pkgver-r$pkgrel.apk"
673
	local pkginfo="$controldir"/.PKGINFO
674
	local sub
Natanael Copa's avatar
Natanael Copa committed
675 676 677
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
678
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
679 680
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')
Natanael Copa's avatar
Natanael Copa committed
681
	local parch="$CARCH"
682 683 684 685 686

	# we need to wait with setting noarch til our build infra can handle it
#	if [ "$arch" = "noarch" ]; then
#		parch="noarch"
#	fi
Natanael Copa's avatar
Natanael Copa committed
687

688
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
689
	if [ -n "$FAKEROOTKEY" ]; then
690
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
691
	fi
692 693
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
694
pkgname = $name
695
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
696 697 698 699 700
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
Natanael Copa's avatar
Natanael Copa committed
701
arch = $parch
Natanael Copa's avatar
Natanael Copa committed
702
origin = $pkgname
Natanael Copa's avatar
Natanael Copa committed
703
EOF
704 705
	local i deps
	deps="$depends"
706
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
707 708
		for i in $install $triggers; do
			local s=${i%=*}
709
			[ "$name" != "${s%.*}" ] && continue
710
			if head -n 1 "$startdir/$s" | grep '^#!/bin/sh' >/dev/null ; then
711 712 713 714 715
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
716 717
	fi
	
718 719 720 721 722 723 724 725 726 727
	local last_commit="$(git_last_commit)$(git_dirty)"
	if [ -n "$last_commit" ]; then
		echo "commit = $last_commit" >> "$pkginfo"
	fi

	get_maintainer
	if [ -n "$maintainer" ]; then
		echo "maintainer = $maintainer" >> "$pkginfo"
	fi

728
	if [ -n "$replaces_priority" ]; then
Natanael Copa's avatar
Natanael Copa committed
729
		echo "replaces_priority = $replaces_priority" >> "$pkginfo"
730 731
	fi

Natanael Copa's avatar
Natanael Copa committed
732
	for i in $license; do
733
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
734 735
	done
	for i in $replaces; do
736
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
737
	done
738
	for i in $deps; do
739
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
740 741
	done
	for i in $conflicts; do
742
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
743 744
	done
	for i in $provides; do
745
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
746
	done
747 748 749 750 751 752
	for i in $triggers; do
		local f=${i%=*}
		local dirs=${i#*=}
		[ "${f%.trigger}" != "$name" ] && continue
		echo "triggers = ${dirs//:/ }" >> "$pkginfo"
	done
753 754 755
	if [ -n "$install_if" ]; then
		echo "install_if = $(echo $install_if)" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
756 757

	local metafiles=".PKGINFO"
758 759 760
	for i in $install $triggers; do
		local f=${i%=*}
		local n=${f%.*}
761
		if [ "$n" != "$name" ]; then
762 763
			continue
		fi
764
		script=${f#$name}
765
		msg "Adding $script"
766
		cp "$startdir/$f" "$controldir/$script" || return 1
767
		chmod +x "$controldir/$script"
768 769
		metafiles="$metafiles $script"
	done
770
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
771
}
772

773 774
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
775
	[ "$arch" = "noarch" ] && return 0
776
	options_has "!tracedeps" && return 0
777
	# lets tell all the .so files this package provides in .provides-so
778 779
	find -name '*.so' -o -name '*.so.[0-9]*' | sed 's:.*/::' \
		>"$controldir"/.provides-so
780 781 782 783 784
	# lets tell all the places we should look for .so files - all rpaths
	scanelf -q -Rr "$dir" | sed -e 's/[[:space:]].*//' -e 's/:/\n/' \
		| sort | uniq \
		>"$controldir"/.rpaths
	# now find the so dependencies
785
	scanelf -Rn "$dir" | tr ' ' ':' | awk -F ":" '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
786 787 788
		| sed 's:,:\n:g' | sort | uniq \
	| while read i; do
		# only add files that are not self provided
789 790
		grep "^$i$" "$controldir"/.provides-so >/dev/null \
			|| echo $i >> "$controldir"/.needs-so
791
	done
Natanael Copa's avatar
Natanael Copa committed
792 793
}

794 795 796 797 798 799 800 801 802 803 804 805
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

806 807 808 809 810
# returns true if this is the -dev package
is_dev_pkg() {
	test "${subpkgname%-dev}" != "$subpkgname"
}

811 812 813 814 815 816 817
# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
		[ "$arch" != "noarch" ] && return 0
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
818 819 820
	elif [ "$arch" != "noarch" ] && ! is_dev_pkg; then
		# we dont want -dev package go to noarch
		warning "No arch specific binaries found so arch should probably be set to \"noarch\""
821 822 823 824
	fi
	return 0
}

825
prepare_package() {
826
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
827
	stripbin
828 829
	prepare_metafiles && prepare_tracedeps || return 1
	archcheck	
830 831 832 833 834 835 836 837
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

838 839 840 841 842 843 844 845 846 847 848 849 850 851 852 853 854 855 856 857 858 859 860
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

861 862 863
trace_apk_deps() {
	local name="$1"
	local dir="$2"
Natanael Copa's avatar
Natanael Copa committed
864
	local i= j= found= autodeps= deppkgs= missing= so_paths= self_provided=
865
	msg "Tracing dependencies for $name..."
866 867 868
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
869
		msg "  added pkgconfig (found /usr/lib/pkgconfig)"
870 871 872 873
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
874
	if [ -f "$dir"/.needs-so ] && grep -q -w '^libpthread.so.*' "$dir"/.needs-so \
875 876
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
877
		msg "  added libgcc (due to libpthread)"
878
	fi
879
	[ -f "$dir"/.needs-so ] && for i in $(cat "$dir"/.needs-so); do
880
		found=
881
		# first check if its provide by same apkbuild
882
		for j in "$dir"/../.control.*/.provides-so; do
883
			grep -w "$i" "$j" >/dev/null || continue
884
			found=${j%/.provides-so}
885
			found=${found##*/.control.}
886
			break
887
		done
888 889 890 891 892 893
		if [ -n "$found" ]; then
			if ! list_has "$found" $self_provided; then
				self_provided="$self_provided $found"
			fi
		else
			missing="$missing $i"
894
		fi
895 896 897
	done

	# find all packages that holds the so files
898 899 900 901 902
	if [ -f "$dir"/.rpaths ]; then
		so_files=$(find_so_files "$dir"/.rpaths $missing) || return 1
		deppkgs=$($APK info -q -W $so_files) || return 1
	fi

903
	for found in $self_provided $deppkgs; do
904
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
905 906 907
			warning "You can remove '$found' from depends"
			continue
		fi
908 909
		if [ "$found" != "$name" ] && ! list_has "$found" $autodeps; then
			autodeps="$autodeps $found"
910
			msg "  added $found"
911
		fi
912
	done
913

914 915 916 917 918 919 920
	[ -z "$autodeps" ] && return 0
	echo "# automatically detected:" >> "$dir"/.PKGINFO
	for i in $autodeps; do
		echo "depend = $i" >> "$dir"/.PKGINFO
	done
}

921 922
create_apks() {
	local file
923
	getpkgver || return 1
Natanael Copa's avatar
Natanael Copa committed
924
	mkdir -p "$PKGDEST"
925
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
926 927 928
		local dir="${file%/.PKGINFO}"
		local name=$(pkginfo_val pkgname $file)
		local ver=$(pkginfo_val pkgver $file)
929
		local apk=$name-$ver.apk
930
		local datadir="$pkgbasedir"/$name
931 932

		trace_apk_deps "$name" "$dir" || return 1
933
		msg "Creating $apk..."
934
		(
935 936
		cd "$datadir"
		# data.tar.gz
937 938 939 940 941 942
		set -- *
		if [ "$1" = '*' ]; then
			touch .dummy
			set -- .dummy
		fi
		tar -c "$@" | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz
943 944 945 946 947 948

		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
949
		cd "$dir"
950 951
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
952
		abuild-sign -q control.tar.gz || exit 1
Natanael Copa's avatar
Natanael Copa committed
953

954 955 956
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
	)
957 958 959
	done
}

960
clean_abuildrepo() {
961
	local apk
962 963 964
	cd "$abuildrepo" || return 1
	
	# remove compat symlink
965
	for d in "$abuildrepo/$CARCH"; do
966 967
		[ -L "$d" ] && rm "$d"
	done
968

969 970
	# remove broken links from abuildrepo
	for apk in *.apk */*.apk; do
971 972 973 974
		if [ -L "$apk" ] && [ ! -f "$apk" ]; then
			rm -f "$apk"
		fi
	done
975
}
976

977
mklinks_abuildrepo() {
978 979
	local apk
	mkdir -p "$abuildrepo"/$CARCH
980
	cd "$abuildrepo" || return 1
981
	# create links for this package
982
	for apk in $(listpkg); do
983
		[ -f "$PKGDEST"/$apk ] || continue
984
		ln -sf "$PKGDEST"/$apk "$abuildrepo"/$CARCH/$apk
985
	done
986 987 988 989 990 991 992 993 994 995 996 997 998 999
}

update_abuildrepo() {
	local d apk
	if ! apk_up2date || [ -n "$force" ]; then
		sanitycheck && builddeps && clean && fetch && unpack \
			&& prepare && mkusers && rootpkg || return 1
	fi

	clean_abuildrepo
	mklinks_abuildrepo

	cd "$abuildrepo"
	local index=$CARCH/APKINDEX.tar.gz
1000

1001
	msg "Updating the cached abuild repository index..."
1002 1003
	local sign=".SIGN.RSA.${SIGN_PUBLIC_KEY##*/}"
	local oldindex=
1004 1005
	if [ -f "$index" ]; then
		oldindex="--index $index"
1006
	fi
1007
	$APK index --quiet $oldindex --output "$index".unsigned \
1008
		--description "$repo $(cd $startdir && git describe)" \
1009 1010
		--rewrite-arch $CARCH \
		$CARCH/*.apk || exit 1
1011
	msg "Signing the index..."
1012 1013 1014
	abuild-sign -q "$index".unsigned || exit 1
	mv "$index".unsigned "$index"
	chmod 644 "$index"
1015 1016
}

1017
# predefined splitfunc doc
1018
default_doc() {
1019
	depends="$depends_doc"
1020
	pkgdesc="$pkgdesc (documentation)"
1021
	arch=${arch_doc:-"noarch"}
1022

Natanael Copa's avatar
Natanael Copa committed
1023
	local i
1024
	for i in doc man info html sgml licenses gtk-doc; do
1025 1026 1027
		if [ -d "$pkgdir/usr/share/$i" ]; then
			mkdir -p "$subpkgdir/usr/share"
			mv "$pkgdir/usr/share/$i" "$subpkgdir/usr/share/"
Natanael Copa's avatar
Natanael Copa committed
1028 1029
		fi
	done
1030 1031 1032
	
	rm -f "$subpkgdir/usr/share/info/dir"

1033 1034 1035
	# remove if empty, ignore error (not empty)
	rmdir "$pkgdir/usr/share" "$pkgdir/usr" 2>/dev/null

Natanael Copa's avatar
Natanael Copa committed
1036 1037 1038
	return 0
}

1039 1040 1041 1042
doc() {
	default_doc
}

1043
# predefined splitfunc mod
1044
default_mod() {
1045
	depends="$kernel $depends_mod"
Natanael Copa's avatar
Natanael Copa committed
1046
	for i in firmware modules; do
1047 1048 1049
		if [ -d "$pkgdir/lib/$i" ]; then
			rm -rf "$subpkgdir/lib"
			mkdir -p "$subpkgdir/lib"
1050
			mv "$pkgdir/lib/$i" "$subpkgdir/lib"
Natanael Copa's avatar
Natanael Copa committed
1051 1052 1053 1054
		fi
	done
}

1055 1056 1057 1058
mod() {
	default_mod
}

1059
# predefined splitfunc dev
1060
default_dev() {
1061
	local i= j=
1062
	depends="$pkgname $depends_dev"
1063 1064
	pkgdesc="$pkgdesc (development files)"

1065 1066 1067 1068
	for i in $origsubpackages; do
		[ "${i%:*}" = "$subpkgname" ] || depends="$depends ${i%:*}"
	done
		
1069
	cd "$pkgdir" || return 0
1070 1071
	for i in usr/include usr/lib/pkgconfig usr/share/aclocal\
			usr/share/gettext usr/bin/*-config	\
1072
			usr/share/vala/vapi usr/share/gir-[0-9]*\
1073
			$(find -name include -type d) 		\
1074
			$(find usr/ -name '*.[acho]' 2>/dev/null); do
1075 1076
		if [ -e "$pkgdir/$i" ] || [ -L "$pkgdir/$i" ]; then
			d="$subpkgdir/${i%/*}"	# dirname $i
Natanael Copa's avatar
Natanael Copa committed
1077
			mkdir -p "$d"
1078
			mv "$pkgdir/$i" "$d"
1079
			rmdir "$pkgdir/${i%/*}" 2>/dev/null
Natanael Copa's avatar
Natanael Copa committed
1080 1081
		fi
	done
1082 1083 1084 1085 1086 1087 1088
	# move *.so links needed when linking the apps to -dev packages
	for i in lib/*.so usr/lib/*.so; do
		if [ -L "$i" ]; then
			mkdir -p "$subpkgdir"/"${i%/*}"
			mv "$i" "$subpkgdir/$i" || return 1
		fi
	done
Natanael Copa's avatar
Natanael Copa committed
1089
	return 0
Natanael Copa's avatar
Natanael Copa committed
1090 1091
}

1092 1093 1094 1095
dev() {
	default_dev
}

1096 1097 1098 1099
is_function() {
	type "$1" 2>&1 | head -n 1 | egrep -q "is a (shell )?function"
}

1100 1101 1102 1103 1104 1105 1106 1107
do_fakeroot() {
	if [ -n "$FAKEROOT" ]; then
		$FAKEROOT -- "$@"
	else
		"$@"
	fi
}

Natanael Copa's avatar
Natanael Copa committed
1108 1109
# build and package in fakeroot
rootpkg() {
1110 1111 1112 1113
	local do_build=build
	cd "$startdir"
	if is_function package; then
		build || return 1
1114
		do_build=package
1115
	fi
Natanael Copa's avatar
Natanael Copa committed
1116
	cd "$startdir"
1117
	[ -n "$FAKEROOT" ] && msg "Entering fakeroot..."
1118
	do_fakeroot "$abuild_path" $color_opt $do_build \
1119
		prepare_subpackages \
1120
		prepare_language_packs \
1121
		prepare_package \
1122
		create_apks
Natanael Copa's avatar
Natanael Copa committed
1123 1124 1125
}

srcpkg() {
1126
	getpkgver || return 1
Natanael Copa's avatar
<